---
- name: Include distribution specific variables
  ansible.builtin.include_vars: "{{ item }}"
  with_first_found:
    - "{{ ansible_distribution }}.yml"
    - "{{ ansible_os_family }}.yml"
  tags: tftp

- name: Configure SELinux if it is active on the system
  ansible.builtin.include_tasks: selinux.yml
  when: >
    ansible_selinux is defined
    and not ansible_selinux
    and ansible_selinux.status == 'enabled'

- name: Install packages
  ansible.builtin.package:
    name: "{{ item }}"
    state: installed
  with_items: "{{ tftp_server_packages }}"
  tags: tftp

- name: Ensure tftp root directory exists
  ansible.builtin.file:
    path: "{{ tftp_server_root_directory }}"
    state: directory
    owner: "{{ tftp_server_user }}"
    group: "{{ tftp_server_group }}"
    mode: "{{ tftp_server_mode }}"
    setype: "{{ tftp_server_setype }}"
  tags: tftp

- name: Copy iPXE boot file
  ansible.builtin.copy:
    src: undionly.kpxe
    dest: "{{ tftp_server_root_directory }}"
    owner: "{{ tftp_server_user }}"
    group: "{{ tftp_server_group }}"
    mode: "0644"

- name: Install configuration file
  ansible.builtin.template:
    dest: "{{ tftp_server_config }}"
    src: systemd_tftp.service.j2
    owner: root
    group: root
    mode: "0644"
  notify:
    - Restart tftp
  tags: tftp

- name: Configure firewall
  ansible.builtin.include_role:
    name: let.services.firewall
    tasks_from: tftpserver

- name: Ensure service is started
  ansible.builtin.service:
    name: "{{ tftp_server_service }}"
    state: started
    enabled: true
  tags: tftp

- name: Install foreman map file
  ansible.builtin.template:
    dest: "{{ tftp_server_foreman_map_file }}"
    src: etc_tftpd.map.j2
    owner: root
    group: root
    mode: "0644"
  notify:
    - Restart tftp
  when: tftp_server_foreman_support
  tags:
    - tftp
    - foreman
